<?php
global $content, $otw_bmp_list, $otw_bmp_list, $buttonTypes, $chosenButtonType, $otw_bmp_name, $otwPluginDevName, $edit;
$message = '';
$massages = array();
$messages[1] = __('Button was saved', $otwPluginDevName);
$messages[2] = __('Button type is required', $otwPluginDevName);
$messages[2] = __('Button name is required', $otwPluginDevName);

$status = 'error';
if (isset($_GET['message']) && $_GET['message'] == 1) {
    $status = 'updated';
}
if (isset($_GET['message']) && isset($messages[$_GET['message']])) {
    $message .= $messages[$_GET['message']];
}
$nextID = 1;
$edit = false;
if (isset($_GET[$otw_bmp_name . '-id']) && isset($otw_bmp_list[$_GET[$otw_bmp_name . '-id']])) {
    $edit = true;
}
if (is_string($content['button_style'])) {
    $buttonStyle = array();
    preg_match_all('/(.+?)\s?\{\s?(.+?)\s?\}/', $content['button_style'], $matches);
    foreach ($matches[0] as $i => $original) {
        foreach (explode(';', $matches[2][$i]) as $attr) {
            if (strlen(trim($attr)) > 0) // for missing semicolon on last element, which is legal
            {
                list($name, $value) = explode(':', $attr);
                $buttonStyle[trim($name)] = str_replace('px', '', trim($value));
                $buttonStyle[trim($name)] = str_replace(' !important', '', $buttonStyle[trim($name)]);
                if ($buttonStyle[trim($name)] === 'auto') {
                    unset($buttonStyle[trim($name)]);
                }
            }
        }
    }
    $content['button_style'] = $buttonStyle;

    if (isset($content['button_style']['text-shadow']) && !empty($content['button_style']['text-shadow'])) {
        $textShadow = explode(' ', $content['button_style']['text-shadow']);
        if (count($textShadow) == 4) {
            $content['button_style']['text-shadow'] = array(
                'horizontal' => $textShadow[0],
                'vertical' => $textShadow[1],
                'blur' => $textShadow[2],
                'color' => $textShadow[3],
            );
        }
    }
}
if (is_string($content['button_icon_box'])) {
    $buttonStyle = array();
    preg_match_all('/(.+?)\s?\{\s?(.+?)\s?\}/', $content['button_icon_box'], $matches);
    foreach ($matches[0] as $i => $original) {
        foreach (explode(';', $matches[2][$i]) as $attr) {
            if (strlen(trim($attr)) > 0) // for missing semicolon on last element, which is legal
            {
                list($name, $value) = explode(':', $attr);
                $buttonStyle[trim($name)] = str_replace('px', '', trim($value));
                $buttonStyle[trim($name)] = str_replace(' !important', '', $buttonStyle[trim($name)]);
                if ($buttonStyle[trim($name)] === 'auto') {
                    unset($buttonStyle[trim($name)]);
                }
            }
        }
    }
    $content['button_icon_box'] = $buttonStyle;
}

if (isset($content['button_background']) && is_string($content['button_background']) && !empty($content['button_background'])) {
    $content['button_background'] = unserialize($content['button_background']);
}
if (isset($content['sub_button_style']) && is_string($content['sub_button_style'])) {
    $subButtonStyle = array();
    preg_match_all('/(.+?)\s?\{\s?(.+?)\s?\}/', $content['sub_button_style'], $matches);
    foreach ($matches[0] as $i => $original) {
        foreach (explode(';', $matches[2][$i]) as $attr) {
            if (strlen(trim($attr)) > 0) // for missing semicolon on last element, which is legal
            {
                list($name, $value) = explode(':', $attr);
                $subButtonStyle[trim($name)] = str_replace('px', '', trim($value));
                $subButtonStyle[trim($name)] = str_replace(' !important', '', $subButtonStyle[trim($name)]);
                if ($subButtonStyle[trim($name)] === 'auto') {
                    unset($subButtonStyle[trim($name)]);
                }
            }
        }
    }
    $content['sub_button_style'] = $subButtonStyle;

    if (isset($content['sub_button_style']['text-shadow']) && !empty($content['sub_button_style']['text-shadow'])) {
        $textShadow = explode(' ', $content['sub_button_style']['text-shadow']);
        if (count($textShadow) == 4) {
            $content['sub_button_style']['text-shadow'] = array(
                'horizontal' => $textShadow[0],
                'vertical' => $textShadow[1],
                'blur' => $textShadow[2],
                'color' => $textShadow[3],
            );
        }
    }
}

if (isset($content['upper_button_style']) && is_string($content['upper_button_style'])) {
    $upperButtonStyle = array();
    preg_match_all('/(.+?)\s?\{\s?(.+?)\s?\}/', $content['upper_button_style'], $matches);
    foreach ($matches[0] as $i => $original) {
        foreach (explode(';', $matches[2][$i]) as $attr) {
            if (strlen(trim($attr)) > 0) // for missing semicolon on last element, which is legal
            {
                list($name, $value) = explode(':', $attr);
                $upperButtonStyle[trim($name)] = str_replace('px', '', trim($value));
                $upperButtonStyle[trim($name)] = str_replace(' !important', '', $upperButtonStyle[trim($name)]);
                if ($upperButtonStyle[trim($name)] === 'auto') {
                    unset($upperButtonStyle[trim($name)]);
                }
            }
        }
    }
    $content['upper_button_style'] = $upperButtonStyle;

    if (isset($content['upper_button_style']['text-shadow']) && !empty($content['upper_button_style']['text-shadow'])) {
        $textShadow = explode(' ', $content['upper_button_style']['text-shadow']);
        if (count($textShadow) == 4) {
            $content['upper_button_style']['text-shadow'] = array(
                'horizontal' => $textShadow[0],
                'vertical' => $textShadow[1],
                'blur' => $textShadow[2],
                'color' => $textShadow[3],
            );
        }
    }
}
if (isset($content['sub_button_hover_style']) && is_string($content['sub_button_hover_style'])) {
    $buttonHoverStyle = array();
    preg_match_all('/(.+?)\s?\{\s?(.+?)\s?\}/', $content['sub_button_hover_style'], $matches);
    foreach ($matches[0] as $i => $original) {
        foreach (explode(';', $matches[2][$i]) as $attr) {
            if (strlen(trim($attr)) > 0) // for missing semicolon on last element, which is legal
            {
                list($name, $value) = explode(':', $attr);
                $buttonHoverStyle[trim($name)] = str_replace('px', '', trim($value));
                $buttonHoverStyle[trim($name)] = str_replace(' !important', '', $buttonHoverStyle[trim($name)]);
            }
        }
    }
    $content['sub_button_hover_style'] = $buttonHoverStyle;
}
if (is_string($content['button_hover_style'])) {
    $buttonHoverStyle = array();
    preg_match_all('/(.+?)\s?\{\s?(.+?)\s?\}/', $content['button_hover_style'], $matches);
    foreach ($matches[0] as $i => $original) {
        foreach (explode(';', $matches[2][$i]) as $attr) {
            if (strlen(trim($attr)) > 0) // for missing semicolon on last element, which is legal
            {
                list($name, $value) = explode(':', $attr);
                $buttonHoverStyle[trim($name)] = str_replace('px', '', trim($value));
                $buttonHoverStyle[trim($name)] = str_replace(' !important', '', $buttonHoverStyle[trim($name)]);
            }
        }
    }
    $content['button_hover_style'] = $buttonHoverStyle;
}
if (isset($content['upper_button_hover_style']) && is_string($content['upper_button_hover_style'])) {
    $buttonHoverStyle = array();
    preg_match_all('/(.+?)\s?\{\s?(.+?)\s?\}/', $content['upper_button_hover_style'], $matches);
    foreach ($matches[0] as $i => $original) {
        foreach (explode(';', $matches[2][$i]) as $attr) {
            if (strlen(trim($attr)) > 0) // for missing semicolon on last element, which is legal
            {
                list($name, $value) = explode(':', $attr);
                $buttonHoverStyle[trim($name)] = str_replace('px', '', trim($value));
                $buttonHoverStyle[trim($name)] = str_replace(' !important', '', $buttonHoverStyle[trim($name)]);
            }
        }
    }
    $content['upper_button_hover_style'] = $buttonHoverStyle;
}
if (is_string($content['button_parent_style'])) {
    $buttonParentStyle = array();
    preg_match_all('/(.+?)\s?\{\s?(.+?)\s?\}/', $content['button_parent_style'], $matches);
    foreach ($matches[0] as $i => $original) {
        foreach (explode(';', $matches[2][$i]) as $attr) {
            if (strlen(trim($attr)) > 0) // for missing semicolon on last element, which is legal
            {
                list($name, $value) = explode(':', $attr);
                $buttonParentStyle[trim($name)] = str_replace('px', '', trim($value));
                $buttonParentStyle[trim($name)] = str_replace(' !important', '', $buttonParentStyle[trim($name)]);
            }
        }
    }
    $content['button_parent_style'] = $buttonParentStyle;

    if (isset($content['button_parent_style']['box-shadow']) && !empty($content['button_parent_style']['box-shadow'])) {
        $boxShadow = explode(' ', $content['button_parent_style']['box-shadow']);
        if (count($boxShadow) == 4) {
            $content['button_parent_style']['box-shadow'] = array(
                'horizontal' => $boxShadow[0],
                'vertical' => $boxShadow[1],
                'blur' => $boxShadow[2],
                'color' => $boxShadow[3],
            );
        }
    }
}
?>
<div class="wrap">
    <div id="icon-edit" class="icon32"><br/></div>
    <h2>
        <?php
        if (!empty($chosenButtonType)) {
            echo $buttonTypes[$chosenButtonType]['page_title'];
        } else {
            _e('Add button', $otwPluginDevName);
        }
        ?>
    </h2>
    <?php if ($message) : ?>
        <div id="message" class="<?php echo $status; ?>">
            <p><?php echo $message; ?></p>
        </div>
    <?php else: ?>
        <div id="message"></div>
    <?php endif; ?>
    <div class="form-wrap <?php echo $otwPluginDevName; ?>_options" id="poststuff">
        <form method="post" action="" class="validate">
            <input type="hidden" id="button-type" name="button_type" value="<?php echo $chosenButtonType; ?>" readonly="readonly" />
            <input type="hidden" name="<?php echo $otwPluginDevName; ?>_action" value="otw_bmp_list_action"/>
            <?php
            wp_original_referer_field(true, 'previous');
            wp_nonce_field($otw_bmp_name . '-list');
            ?>
            <div id="post-body">
                <div id="post-body-content">
                    <?php
                    include_once(
                        dirname(__FILE__) . DIRECTORY_SEPARATOR
                        . 'views' . DIRECTORY_SEPARATOR
                        . 'otw_bmp_add.php'
                    );
                    ?>
                </div>
            </div>
        </form>
    </div>

    <div class="bmp-live_preview-holder">
    <div class="bmp-live_preview-container">
	<div id="otw_bmp_live_preview_loader"></div>
	<div id="otw_bmp_live_preview"></div>
        <link rel="stylesheet" id="google-font" type="text/css">
        <link rel="stylesheet" id="dynamic-sub-styles" />
        <link rel="stylesheet" id="dynamic-styles" />
        <link rel="stylesheet" id="dynamic-upper-styles" />
        <div class="live_previews js-preview"></div>
    </div>
    </div>
</div>