function otw_bmp_init() {

    var otwButton = jQuery('#post-body-content').otw_bmp_button({
        methods: {
            upper_text: upper_text,
            upper_style: upper_style,
            upper_text_shadow: upper_text_shadow,
            upper_hover_style: upper_hover_style
        },
        baseLinkClasses: [
            'otw-bmp-button'
        ],
        iconClasses: [
            'fa'
        ],
        baseClasses: [
            ''
        ],
        classes: [
        ],
        contentClass: 'otw-bmp-download-button-content',
        lowerClass: 'otw-bmp-download-lower',
        upperClass: 'otw-bmp-download-upper'
    });
    
}

function upper_hover_style(element, button) {
    var self = this;
    if (typeof element.data('property') !== 'undefined') {
        var property = element.data('property');
        var currentStyle = self.parseCSS(jQuery('#dynamic-upper-styles').html());
        var linkHoverStyle = {};
        if (typeof currentStyle['a.otw-bmp-button:hover .' + self.options.upperClass] !== 'undefined') {
            linkHoverStyle = currentStyle['a.otw-bmp-button:hover .' + self.options.upperClass];
        }
        linkHoverStyle[property] = element.val();
        currentStyle['a.otw-bmp-button:hover .' + self.options.upperClass] = linkHoverStyle;

        // @todo - fix to the self.previewArea
        var style_tag = '<style id="dynamic-upper-styles" type="text/css">' +
            self.objectToCSS(currentStyle) +
            '</style>';
        self.previewArea.parent().find('#dynamic-upper-styles').replaceWith(style_tag);
    }
}

function upper_text(element, button) {
    var self = this;
    button = self.previewArea.find('a');
    if (button.find('.' + self.options.upperClass).length > 0) {
        button.find('.' + self.options.upperClass).text(element.val());
    } else {
        button.append(jQuery('<span/>', {
            'class': '.' + self.options.upperClass,
            text: element.val()
        }));
    }
}

function upper_style(element, button) {
    var self = this;
    if (typeof element.data('property') !== 'undefined') {
        var property = element.data('property');
        var styleProperty = {};
        styleProperty[property] = element.val();
        self.previewArea.find('a .' + self.options.upperClass).css(styleProperty);
    }
}

function upper_text_shadow(element, button) {
    var self = this;
    var theShadow = "";
    var shadowHOffset = "";
    var shadowVOffset = "";
    var shadowBlur = "";
    var shadowColor = "";

    shadowHOffset = document.getElementById("upper_button_text_shadow_h").value;
    shadowVOffset = document.getElementById("upper_button_text_shadow_v").value;
    shadowBlur = document.getElementById("upper_button_text_shadow_b").value;
    shadowColor = document.getElementById("upper_button_text_shadow_color").value;

    if (theShadow === "") {
        theShadow = shadowHOffset + "px " + shadowVOffset + "px " + shadowBlur + "px " + shadowColor;
    }
    var styleProperty = {};
    styleProperty['textShadow'] = theShadow;

    self.previewArea.find('a .' + self.options.upperClass).css(styleProperty);
}