<?php global $content,
             $config,
             $selectFontSizeData,
             $otwPluginDevName,
             $buttonSections,
             $editSections,
             $buttonTypes,
             $edit,
             $chosenButtonType; ?>
<?php
if (isset($buttonTypes[$chosenButtonType]['css_files']) && !empty($buttonTypes[$chosenButtonType]['css_files'])) {
    foreach ($buttonTypes[$chosenButtonType]['css_files'] as $css_file_id => $css_file) {
        ?>
        <link rel='stylesheet' id='<?php echo $css_file_id; ?>'  href='<?php
        echo plugins_url() .
            DIRECTORY_SEPARATOR .
            'otw-buttons-mega-pack' .
            DIRECTORY_SEPARATOR .
            'frontend' .
            DIRECTORY_SEPARATOR .
            'css' .
            DIRECTORY_SEPARATOR .
            $css_file;
        ?>' type='text/css' media='all' />
        <?php
    }
}
?>
<div class="otw-settings-style-holder">
    <div class="bmp-accordion-container">

        <ul class="outer-border">
            <?php
            $isButtonIconSection = false;
            $cssClasses = '';
            if (isset($buttonTypes[$chosenButtonType]['default_classes'])) {
                $cssClasses = join(' ', $buttonTypes[$chosenButtonType]['default_classes']);
            }
            ?>
            <input type="hidden" name="css-classes" id="css-classes" value="<?php echo $cssClasses; ?>" readonly="readonly" disabled="disabled" />
            <?php
            $iconClasses = '';
            if (isset($buttonTypes[$chosenButtonType]['icon_classes'])) {
                $iconClasses = join(' ', $buttonTypes[$chosenButtonType]['icon_classes']);
            }
            ?>
            <input type="hidden" name="icon-classes" id="icon-classes" value="<?php echo $iconClasses; ?>" readonly="readonly" disabled="disabled" />
            <?php foreach ($editSections as $sectionId => $section) : ?>
                <?php if (!isset($buttonSections[$chosenButtonType][$sectionId]) || empty($buttonSections[$chosenButtonType][$sectionId])) {
                    continue;
                }
                ?>
                <!-- Style Tab -->
                <li class="control-section accordion-section add-page top">
                    <h3 class="accordion-section-title hndl" tabindex="4" title="<?php echo $section['title']; ?>">
                        <?php echo $section['title']; ?>
                    </h3>
                    <div class="otw-accordion-section-content">
                        <div class="inside">
                            <table class="form-table">
                                <tbody>
                                <?php foreach ($section['elements'] as $sectionElementKey => $sectionElement) {
                                    if (!in_array($sectionElementKey, $buttonSections[$chosenButtonType][$sectionId])) {
                                        continue;
                                    }
                                    if ($sectionElement['enabled'] === true) {
                                        if (isset($sectionElement['grouped']) && $sectionElement['grouped'] === true) {
                                        ?><?php
                                            if (isset($sectionElement['children']) && !empty($sectionElement['children'])) {
                                                foreach ($sectionElement['children'] as $childName => $child) {
                                                    if (@$child['enabled'] !== true) {
                                                        continue;
                                                    }
                                                    $funcName = $child['admin_func'];

                                                    $config = array();
                                                    if (isset($child['config'])) {
                                                        $config = $child['config'];
                                                    }

                                                    if (isset($child['config'])) {
                                                        $config = $child['config'];
                                                    }
                                                    if (isset($content[$sectionElement['section']][$sectionElementKey][$childName])) {
                                                        $config['value'] = $content[$sectionElement['section']][$sectionElementKey][$childName];
                                                    }
                                                    echo $funcName($content, $childName, $child, $config);
                                                }
                                            }
                                            ?>
                                        <?php
                                        } else {
                                            $funcName = $sectionElement['admin_func'];
                                            $config = array();
                                            if (isset($sectionElement['config'])) {
                                                $config = $sectionElement['config'];
                                            }
                                            
                                            if (isset($sectionElement['section']) && isset($content[$sectionElement['section']][$sectionElementKey])) {
                                                $config['value'] = $content[$sectionElement['section']][$sectionElementKey];
                                            }
                                            
                                            if (empty(@$config['value']) && isset($content[$sectionElementKey])) {
                                                $config['value'] = $content[$sectionElementKey];
                                            }
                                            
                                            if (isset($sectionElement['name']) && empty(@$config['value']) && isset($content[$sectionElement['name']])) {
                                                $config['value'] = $content[$sectionElement['name']];
                                            }
                                            
                                            if (function_exists($funcName)) {
                                                if (isset($config['value'])) {
                                                    $config['value'] = str_replace(' !important', '', $config['value']);
                                                }
                                                if ($sectionElementKey == 'icon') {
                                                    $isButtonIconSection = true;
                                                }
                                                echo $funcName($content, $sectionElementKey, $sectionElement, $config);
                                            }
                                        }
                                    }
                                }
                                ?>
                                </tbody>
                            </table>
                        </div> <!-- .inside -->
                    </div><!-- .otw-accordion-section-content -->
                </li><!-- .accordion-section -->
                <!-- Style Tab -->
            <?php endforeach; ?>
        </ul>
        <?php if (!$isButtonIconSection && isset($buttonTypes[$chosenButtonType]['icon_classes'])) : ?>
        <input type="hidden" name="button_icon" id="button_icon" value="<?php echo join(' ', $buttonTypes[$chosenButtonType]['icon_classes']); ?>" readonly="readonly" />
        <?php endif; ?>
    </div>
</div>